PROGRAM u11_sudoku
  IMPLICIT NONE

  INTEGER, DIMENSION(:,:), ALLOCATABLE:: sudoku
  INTEGER:: n, dimen, i,j,k
  LOGICAL:: line, all_lines, column, all_columns, array, all_arrays

  WRITE(*,*) 'Please enter sudoku dimension:'
  READ(*,*) n
  dimen = n ** 2
  ALLOCATE(sudoku(dimen,dimen))

  WRITE(*,*) 'Please enter sudoku to test:'
  DO i = 1, dimen
    READ(*,*) sudoku(i,:)
  END DO

  all_lines = .TRUE.
  DO i = 1, dimen
    line = ALL(ANY(sudoku==i, 2))
    WRITE(*,*) 'Number ', i, ' is in every line: ', line
    all_lines = all_lines .AND. line
  END DO

  all_columns = .TRUE.
  DO i = 1, dimen
    column = ALL(ANY(sudoku==i, 1))
    WRITE(*,*) 'Number ', i, ' is in every column: ', column
    all_columns = all_columns .AND. column
  END DO

  all_arrays = .TRUE.
  DO k = 1, dimen
    array = .TRUE.
    DO i = 1, n
      DO j = 1 , n
        array = array .AND. ANY(sudoku((i-1)*n+1:i*n,(j-1)*n+1:j*n)==k)
      END DO
    END DO
    WRITE(*,*) 'Number ', k, ' is in every array: ', array
    all_arrays = all_arrays .AND. array
  END DO

  IF(all_lines .AND. all_columns .AND. all_arrays) THEN
    WRITE(*,*) 'The sudoku has been solved correctly.'
  ELSE
    WRITE(*,*) 'The sudoku has not been solved correctly.'
  END IF

  DEALLOCATE(sudoku)

END PROGRAM u11_sudoku
