
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!Dieses MODULE ist von der Übung am 26.04. und enthält einige !!!
!!!Grundfunktionalitäten für eine doppelt verkettete Liste !!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

MODULE dbllistmod
  IMPLICIT NONE

  PRIVATE
  PUBLIC:: content,elem,list,INIT,EMPTY,PUSH,POP,HEAD,       &
 &         INJECT,EJECT,INS_AFTER,DEL_ELEM,DELETE

  TYPE  content
    !! Daten
  END TYPE  content

  TYPE elem
    TYPE(content) :: cont
    TYPE(elem),POINTER :: next => NULL()
    TYPE(elem),POINTER :: prev => NULL()
  END TYPE

  TYPE list
    INTEGER :: length = 0
    TYPE(elem),POINTER :: head => NULL()
    TYPE(elem),POINTER :: tail => NULL()
  END TYPE

CONTAINS

  !! INIT(l)
  SUBROUTINE  INIT(l)
    TYPE(list),INTENT(OUT) :: l

    NULLIFY (l%head,l%tail)
    l%length = 0
  END SUBROUTINE

  !! EMPTY(l)
  FUNCTION  EMPTY(l)
    TYPE(list), INTENT(IN) :: l
    LOGICAL :: EMPTY

    EMPTY = .NOT. ASSOCIATED(l%head) !! = l%length == 0
  END FUNCTION

  !! PUSH(l,e) !head einf.
  SUBROUTINE  PUSH(l,e)
    TYPE(list),INTENT(INOUT) :: l
    TYPE(content), INTENT(IN) :: e
    TYPE(elem),POINTER :: p

    ALLOCATE(p)
    p%cont = e
    p%next => l%head
    l%head => p
    l%length = l%length + 1
    IF(l%length == 1)THEN
      l%tail => p
    ELSE
      p%next%prev => p
    END iF
    !NULLIFY(p%prev)
  END SUBROUTINE

  !! POP(l,e) !head entf.
  SUBROUTINE  POP(l,e)
    TYPE(list),INTENT(INOUT) :: l
    TYPE(content),INTENT(OUT),OPTIONAL :: e
    TYPE(elem),POINTER :: p

    IF(EMPTY(l))THEN
      WRITE(*,*) ' Can not pop from empty list!'
    ELSE
      p => l%head
      IF(PRESENT(e))THEN
        e = p%cont
      END IF
      l%head => p%next
      DEALLOCATE (p)
      l%length = l%length - 1
      IF(l%length == 0)THEN
        NULLIFY(l%tail)
      ELSE
        NULLIFY(l%head%prev)
      END IF
    END IF
  END SUBROUTINE

  !! HEAD(l) !head Wert
  FUNCTION  HEAD(l)
    TYPE(list),INTENT(IN) :: l
    TYPE(content) :: HEAD

    IF(.NOT.EMPTY(l))THEN
      HEAD = l%head%cont
    ELSE                !!! Output in a function can be a PROBLEM !!!
      WRITE(*,*) ' Can not get head of empty list!'
    END IF
  END FUNCTION

  !! INJECT(l,e) !tail einf.
  SUBROUTINE INJECT(l,e)
    TYPE(list),INTENT(INOUT) :: l
    TYPE(content), INTENT(IN) :: e
    TYPE(elem),POINTER :: p

    ALLOCATE(p)
    p%cont = e
    p%prev => l%tail
    l%tail => p
    l%length = l%length + 1
    IF(l%length == 1)THEN
      l%head => p
    ELSE
      p%prev%next => p
    END iF
    !NULLIFY(p%next)
  END SUBROUTINE

  !! EJECT(l,e) !tail entf.
  SUBROUTINE  EJECT(l,e)
    TYPE(list),INTENT(INOUT) :: l
    TYPE(content),INTENT(OUT),OPTIONAL :: e
    TYPE(elem),POINTER :: p

    IF(.NOT.EMPTY(l))THEN
      p => l%tail
      IF(PRESENT(e))THEN
        e = p%cont
      END IF
      l%tail => p%prev
      DEALLOCATE (p)
      l%length = l%length - 1
      IF(l%length == 0)THEN
        NULLIFY(l%head)
      ELSE
        NULLIFY(l%tail%next)
      END IF
    ELSE
      WRITE(*,*) ' Can not pop from empty list!'
    END IF
  END SUBROUTINE

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!Die letzten SUBROUTINEs sind noch aufzustellen!!!
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  !! INS_AFTER(l,p,e)
  SUBROUTINE INS_AFTER(l,p,e)
    TYPE(list),INTENT(INOUT) :: l
    TYPE(content),INTENT(OUT) :: e
    TYPE(elem),POINTER,INTENT(INOUT) :: p
    TYPE(elem),POINTER :: q

  END SUBROUTINE

  !! DEL_ELEM(l,p,e)
  SUBROUTINE DEL_ELEM(l,p,e)
    TYPE(list),INTENT(INOUT) :: l
    TYPE(content),INTENT(OUT),OPTIONAL :: e
    TYPE(elem),POINTER,INTENT(INOUT) :: p

  END SUBROUTINE

  !! DELETE

END MODULE


PROGRAM dbllist
  USE dbllistmod
  IMPLICIT NONE

  !! Hauptprogramm

END PROGRAM
